# Module: `wibox.layout.align`

The `align` layout has three slots for child widgets.

On its main axis, it will use as much space as is available to it and distribute that to its child widgets by stretching or shrinking them based on the chosen expand strategy. On its secondary axis, the biggest child widget determines the size of the layout, but smaller widgets will not be stretched to match it.

In its default configuration, the layout will give the first and third widgets only the minimum space they ask for and it aligns them to the outer edges. The remaining space between them is made available to the widget in slot two.

This layout is most commonly used to split content into left/top, center and right/bottom sections. As such, it is usually seen as the root layout in awful.wibar.

You may also fill just one or two of the widget slots, the expand algorithm will adjust accordingly.

### Usage:

    wibox.widget {
        generic_widget( "first"  ),
        generic_widget( "second" ),
        generic_widget( "third"  ),
        layout  = wibox.layout.align.horizontal
    }

### Class Hierarchy

- gears.object
- - wibox.widget.base
  - - wibox.layout.align

### Info:

- Copyright: 2010 Uli Schlachter
- Originally authored by: Uli Schlachter
  (Full contributors list available on our github project)

## Constructors

wibox.layout.align.horizontal (left, middle, right) | Returns a new horizontal align layout. |
wibox.layout.align.vertical (top, middle, bottom) | Returns a new vertical align layout. |

## Object properties

first | widget or nil | The widget in slot one. |
second | widget or nil | The widget in slot two. |
third | widget or nil | The widget in slot three. |
expand | string | Set the expand mode, which determines how child widgets expand to take up unused space. |
children | table | Get or set the children elements. | Inherited from wibox.widget.base
all_children | table | Get all direct and indirect children widgets. | Inherited from wibox.widget.base
forced_height | number or nil | Force a widget height. | Inherited from wibox.widget.base
forced_width | number or nil | Force a widget width. | Inherited from wibox.widget.base
opacity | number | The widget opacity (transparency). | Inherited from wibox.widget.base
visible | boolean | The widget visibility. | Inherited from wibox.widget.base
buttons | table | The widget buttons. | Inherited from wibox.widget.base

## Object methods

:set (index, widget2) -> boolean | Set a widget at a specific index, replacing the current one. |
:replace_widget (widget, widget2, recursive) -> boolean | Replace the first instance of `widget` in the layout with `widget2`. |
:swap (index1, index2) -> boolean | Swap 2 widgets in a layout. |
:swap_widgets (widget1, widget2, recursive) -> boolean | Swap 2 widgets in a layout. |
:reset () | Reset the layout. |
:add_button (button) | Add a new awful.button to this widget. | Inherited from wibox.widget.base
:emit_signal_recursive (signal_name, ...) | Emit a signal and ensure all parent widgets in the hierarchies also forward the signal. | Inherited from wibox.widget.base
:index (widget, recursive, ...) -> (number, widget, table) | Get the index of a widget. | Inherited from wibox.widget.base
:connect_signal (name, func) | Connect to a signal. | Inherited from gears.object
:weak_connect_signal (name, func) | Connect to a signal weakly. | Inherited from gears.object
:disconnect_signal (name, func) | Disconnect from a signal. | Inherited from gears.object
:emit_signal (name, ...) | Emit a signal. | Inherited from gears.object

## Signals

widget::layout_changed | When the layout (size) change. | Inherited from wibox.widget.base
widget::redraw_needed | When the widget content changed. | Inherited from wibox.widget.base
button::press | When a mouse button is pressed over the widget. | Inherited from wibox.widget.base
button::release | When a mouse button is released over the widget. | Inherited from wibox.widget.base
mouse::enter | When the mouse enter a widget. | Inherited from wibox.widget.base
mouse::leave | When the mouse leave a widget. | Inherited from wibox.widget.base

## Constructors

🔗 wibox.layout.align.horizontal (left, middle, right)
  Returns a new horizontal align layout.

  The three widget slots are aligned left, center and right.

  Additionally, this creates the aliases `set_left`, `set_middle` and `set_right` to assign first, second and third respectively.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  left | Optional | widget | Widget to be put in slot one.
  middle | Optional | widget | Widget to be put in slot two.
  right | Optional | widget | Widget to be put in slot three.

🔗 wibox.layout.align.vertical (top, middle, bottom)
  Returns a new vertical align layout.

  The three widget slots are aligned top, center and bottom.

  Additionally, this creates the aliases `set_top`, `set_middle` and `set_bottom` to assign first, second and third respectively.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  top | Optional | widget | Widget to be put in slot one.
  middle | Optional | widget | Widget to be put in slot two.
  bottom | Optional | widget | Widget to be put in slot three.

## Object properties

🔗 first widget or nil · 1 signal
  The widget in slot one.

  This is the widget that is at the left/top.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : This spot will be empty. Depending on how large the second widget is an and the value of `expand`, it might mean it will leave an empty area.

  Click to display more

  ### Emit signals:

  - `property::first` When the first value changes.
  - `self` wibox.layout.align The object which changed (useful when connecting many object to the same callback).
  - `new_value` first The new value affected to the property.
🔗 second widget or nil · 1 signal
  The widget in slot two.

  This is the centered one.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : When this property is `nil`, then there will be an empty area.

  Click to display more

  ### Emit signals:

  - `property::second` When the second value changes.
  - `self` wibox.layout.align The object which changed (useful when connecting many object to the same callback).
  - `new_value` second The new value affected to the property.
🔗 third widget or nil · 1 signal
  The widget in slot three.

  This is the widget that is at the right/bottom.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : This spot will be empty. Depending on how large the second widget is an and the value of `expand`, it might mean it will leave an empty area.

  Click to display more

  ### Emit signals:

  - `property::third` When the third value changes.
  - `self` wibox.layout.align The object which changed (useful when connecting many object to the same callback).
  - `new_value` third The new value affected to the property.
🔗 expand string
  Set the expand mode, which determines how child widgets expand to take up unused space.

  Attempting to set any other value than one of those three will fall back to `"inside"`.

  ### Constraints:

  Default value | : `"inside"`
  Valid values: | : How to use unused space.
  `"inside"` | : The widgets in slot one and three are set to their minimal required size. The widget in slot two is then given the remaining space. This is the default behaviour.
  `"outside"` | : The widget in slot two is set to its minimal required size and placed in the center of the space available to the layout. The other widgets are then given the remaining space on either side. If the center widget requires all available space, the outer widgets are not drawn at all.
  `"none"` | : All widgets are given their minimal required size or the remaining space, whichever is smaller. The center widget gets priority.

🔗 children table · Inherited from wibox.widget.base
  Get or set the children elements.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of wibox.widget.

  ### See also:

  wibox.widget.base.all_children |  |

🔗 all_children table · Inherited from wibox.widget.base
  Get all direct and indirect children widgets. This will scan all containers recursively to find widgets Warning: This method it prone to stack overflow if there is a loop in the widgets hierarchy. A hierarchy loop is when a widget, or any of its children, contain (directly or indirectly) itself.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of wibox.widget.

  ### See also:

  wibox.widget.base.children |  |

🔗 forced_height number or nil · Inherited from wibox.widget.base
  Force a widget height.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : Let the layout decide the height. Usually using the widget native height.
  number | : Enforce a number of pixels.
  Unit | : pixel
  Negative allowed | : false

  ### See also:

  wibox.widget.base.forced_width |  |

🔗 forced_width number or nil · Inherited from wibox.widget.base
  Force a widget width.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : Let the layout decide the width. Usually using the widget native width.
  number | : Enforce a number of pixels.
  Unit | : pixel
  Negative allowed | : false

  ### See also:

  wibox.widget.base.forced_height |  |

🔗 opacity number · Inherited from wibox.widget.base
  The widget opacity (transparency).

  ### Constraints:

  Default value | : `1.0`
  Unit | : A gradient between transparent (`0.0`) and opaque (`1.0`).
  Minimum value | : 0.0
  Maximum value | : 1.0

  ### See also:

  wibox.widget.base.visible |  |

🔗 visible boolean · Inherited from wibox.widget.base
  The widget visibility.

  ### Constraints:

  Default value | : `true`
  Valid values | : `true` or `false`.

  ### See also:

  wibox.widget.base.opacity |  |

🔗 buttons table · Inherited from wibox.widget.base
  The widget buttons.

  The table contains a list of awful.button objects.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of awful.button.

  ### See also:

  awful.button | Create easily new buttons objects ignoring certain modifiers. | module

## Object methods

🔗 :set (index, widget2) -> boolean · 1 signal
  Set a widget at a specific index, replacing the current one.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | A widget or a widget index
  widget2 |  | widget | The widget to replace the previous one with

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.
  Click to display more

  ### Emit signals:

  - `widget::replaced`
  - `self` `widget` The layout.
  - `widget` `widget` The inserted widget.
  - `previous` `widget` The previous widget.
  - `index` `number` The replaced index.
🔗 :replace_widget (widget, widget2, recursive) -> boolean · 1 signal
  Replace the first instance of `widget` in the layout with `widget2`.

  ### Parameters:

  Name |  | Type(s) | Description | Default value
  --- | --- | --- | --- | ---
  widget |  | widget | The widget to replace | Not applicable
  widget2 |  | widget | The widget to replace `widget` with | Not applicable
  recursive | Optional | boolean | Recurse into all compatible layouts to find the widget. | `false`

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.
  Click to display more

  ### Emit signals:

  - `widget::replaced`
  - `self` `widget` The layout.
  - `widget` `widget` index The inserted widget.
  - `previous` `widget` The previous widget.
  - `index` `number` The replaced index.
🔗 :swap (index1, index2) -> boolean · 1 signal
  Swap 2 widgets in a layout.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index1 |  | number | The first widget index
  index2 |  | number | The second widget index

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.
  Click to display more

  ### Emit signals:

  - `widget::swapped`
  - `self` `widget` The layout.
  - `widget1` `widget` The first widget.
  - `widget2` `widget` The second widget.
  - `index1` `number` The first index.
  - `index1` `number` The second index.
🔗 :swap_widgets (widget1, widget2, recursive) -> boolean · 1 signal
  Swap 2 widgets in a layout.

  If `widget1` is present multiple time, only the first instance is swapped.

  Calls set internally, so the signal `widget::replaced` is emitted for both widgets as well.

  ### Parameters:

  Name |  | Type(s) | Description | Default value
  --- | --- | --- | --- | ---
  widget1 |  | widget | The first widget | Not applicable
  widget2 |  | widget | The second widget | Not applicable
  recursive | Optional | boolean | Recurse into all compatible layouts to find the widget. | `false`

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.

  ### See also:

  set | Set a widget at a specific index, replacing the current one. | object methods

  Click to display more

  ### Emit signals:

  - `widget::swapped`
  - `self` `widget` The layout.
  - `widget1` `widget` The first widget.
  - `widget2` `widget` The second widget.
  - `index1` `number` The first index.
  - `index1` `number` The second index.
🔗 :reset () · 1 signal
  Reset the layout. This removes all widgets from the layout.
  Click to display more

  ### Emit signals:

  - `widget::reset`
  - `self` `widget` The layout.
🔗 :add_button (button) · Inherited from wibox.widget.base
  Add a new awful.button to this widget.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  button |  | awful.button | The button to add.

🔗 :emit_signal_recursive (signal_name, ...) · Inherited from wibox.widget.base
  Emit a signal and ensure all parent widgets in the hierarchies also forward the signal.

  This is useful to track signals when there is a dynamic set of containers and layouts wrapping the widget.

  Note that this function has some flaws:

  1. The signal is only forwarded once the widget tree has been built. This happens after all currently scheduled functions have been executed. Therefore, it will not start to work right away. 2. In case the widget is present multiple times in a single widget tree, this function will also forward the signal multiple times (once per upward tree path). 3. If the widget is removed from the widget tree, the signal is still forwarded for some time, similar to the first case.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  signal_name |  | string |
  ... |  |  | Other arguments

🔗 :index (widget, recursive, ...) -> (number, widget, table) · Inherited from wibox.widget.base
  Get the index of a widget.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget to look for.
  recursive | Optional | boolean | Recursively check accross the sub-widgets hierarchy.
  ... | Optional | widget | Additional widgets to add at the end of the sub-widgets hierarchy "path".

  ### Returns:

  1. number The widget index.
  2. widget The parent widget.
  3. table The hierarchy path between "self" and "widget".
🔗 :connect_signal (name, func) · Inherited from gears.object
  Connect to a signal.

  **Usage example output**:

  In slot [obj] nil nil nil In slot [obj] foo bar 42

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback to call when the signal is emitted.

  ### Usage:

      local o = gears.object{}
      -- Function can be attached to signals
      local function slot(obj, a, b, c)
          print("In slot", obj, a, b, c)
      end
      o:connect_signal("my_signal", slot)
      -- Emitting can be done without arguments. In that case, the object will be
      -- implicitly added as an argument.
      o:emit_signal "my_signal"
      -- It is also possible to add as many random arguments are required.
      o:emit_signal("my_signal", "foo", "bar", 42)
      -- Finally, to allow the object to be garbage collected (the memory freed), it
      -- is necessary to disconnect the signal or use weak_connect_signal
      o:disconnect_signal("my_signal", slot)
      -- This time, the slot wont be called as it is no longer connected.
      o:emit_signal "my_signal"

🔗 :weak_connect_signal (name, func) · Inherited from gears.object
  Connect to a signal weakly.

  This allows the callback function to be garbage collected and automatically disconnects the signal when that happens. **Warning:** Only use this function if you really, really, really know what you are doing.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback to call when the signal is emitted.

🔗 :disconnect_signal (name, func) · Inherited from gears.object
  Disconnect from a signal.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback that should be disconnected.

🔗 :emit_signal (name, ...) · Inherited from gears.object
  Emit a signal.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal
  ... |  |  | Extra arguments for the callback functions. Each connected function receives the object as first argument and then any extra arguments that are given to emit_signal()

## Signals

🔗 widget::layout_changed · Inherited from wibox.widget.base
  When the layout (size) change. This signal is emitted when the previous results of `:layout()` and `:fit()` are no longer valid. Unless this signal is emitted, `:layout()` and `:fit()` must return the same result when called with the same arguments.

  ### See also:

  widget::redraw_needed | When the widget content changed. | signals

🔗 widget::redraw_needed · Inherited from wibox.widget.base
  When the widget content changed. This signal is emitted when the content of the widget changes. The widget will be redrawn, it is not re-layouted. Put differently, it is assumed that `:layout()` and `:fit()` would still return the same results as before.

  ### See also:

  widget::layout_changed | When the layout (size) change. | signals

🔗 button::press · Inherited from wibox.widget.base
  When a mouse button is pressed over the widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  lx |  | number | The horizontal position relative to the (0,0) position in the widget.
  ly |  | number | The vertical position relative to the (0,0) position in the widget.
  button |  | number | The button number.
  mods |  | table | The modifiers (mod4, mod1 (alt), Control, Shift)
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 button::release · Inherited from wibox.widget.base
  When a mouse button is released over the widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  lx |  | number | The horizontal position relative to the (0,0) position in the widget.
  ly |  | number | The vertical position relative to the (0,0) position in the widget.
  button |  | number | The button number.
  mods |  | table | The modifiers (mod4, mod1 (alt), Control, Shift)
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 mouse::enter · Inherited from wibox.widget.base
  When the mouse enter a widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 mouse::leave · Inherited from wibox.widget.base
  When the mouse leave a widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

generated by LDoc 1.5.0